
document.addEventListener('DOMContentLoaded', event => {
	console.log('DOM CONTENT LOADED')
	document.querySelector('button#update').addEventListener('click', event => {
		console.log('UPDATE BUTTON CLICKED')
		const score = parseInt(document.querySelector('input').value)
		updateScore(score)
	})
	document.querySelector('button#end').addEventListener('click', event => {
		console.log('END BUTTON CLICKED')
		endGame(parseInt(document.querySelector('input').value))
		ScormProcessFinish()
	})
})

function updateScore(score) {
	score = parseInt(score)
	console.log(`score: ${score}`)
	ScormProcessSetValue('cmi.core.score.raw', parseInt(score))
}

function endGame(score) {
	updateScore(score)
	// set the status
	const mastery = parseInt(ScormProcessGetValue('cmi.student_data.mastery_score'))
	console.log(`mastery: (${mastery})`)
	if(!isNaN(mastery)) { // NaN if mastery score not provided by the API
		const status = parseInt(score) >= mastery ? 'passed' : 'failed' // if mastery score then pass/fail
		console.log(`status: (${status})`)
		ScormProcessSetValue('cmi.core.lesson_status', status)
	} else {
		console.log('status is: (completed)')
		ScormProcessSetValue('cmi.core.lesson_status', 'completed') // if no mastery then completed
	}
}

window.addEventListener('load', event => {
	console.log('LOAD')
	ScormProcessInitialize()
	const completionStatus = ScormProcessGetValue('cmi.core.lesson_status')
	if (completionStatus == 'not attempted') {
		console.log('not attempted')
		ScormProcessSetValue('cmi.core.lesson_status', 'incomplete')
	}
	const name = ScormProcessGetValue('cmi.core.student_name')
	console.log(`student name: ${name}`)
	document.querySelector('p').innerText = name
	const username = ScormProcessGetValue('cmi.core.student_id')
	console.log(`student ID: ${username}`)
	ScormProcessSetValue('cmi.core.score.min', 0)
	ScormProcessSetValue('cmi.core.score.max', 100)
})

window.addEventListener('beforeunload', event => {
	console.log('BEFOREUNLOAD')
	ScormProcessSetValue('cmi.core.exit', '')
	ScormProcessFinish()
})

window.addEventListener('unload', event => {
	console.log('UNLOAD')
	ScormProcessSetValue("cmi.core.exit", "")
	ScormProcessFinish()
})
